Ruby - Bug #18241

Question on String Concatentation Documentation
10/05/2021 03:18 PM - hernanat (Anthony Hernandez)

Status: Closed
Priority: Normal
Assignee:

Target version:

ruby -v: Backport: 2.6: UNKNOWN, 2.7: UNKNOWN, 3.0:
DONE

Description

Hello,

I noticed that the documentation for << and concat both state that the result of each operation is a new string.

However, while doing some experimenting myself | noticed that this doesn't seem to be the case. The result has the same object id
and memory address as the initial string.

| also noticed that the underlying C code fore both of these does seem to return the original string pointer at the end.

Is this a documentation issue, or is there something else going on that I'm missing? If the former, I'm happy to put up a PR to fix. If
it's the latter, I'd appreciate any explanation.

Thanks

Anthony

Related issues:
Has duplicate Ruby - Bug #18261: String#prepend inconsistent documentation Closed

Associated revisions

Revision c6706f15af123bdbb3b39a21903d85¢78462d047 - 10/05/2021 03:39 PM - jeremyevans (Jeremy Evans)

Fix documentation for String#{<<,concat,prepend}

These methods mutate and return the receiver, they don't create
and return a new string.

Fixes [Bug #18241]
Revision c6706f15af123bdbb3b39a221903d85¢78462d047 - 10/05/2021 03:39 PM - jeremyevans (Jeremy Evans)
Fix documentation for String#{<<,concat,prepend}

These methods mutate and return the receiver, they don't create
and return a new string.

Fixes [Bug #18241]
Revision c6706f15 - 10/05/2021 03:39 PM - jeremyevans (Jeremy Evans)
Fix documentation for String#{<<,concat,prepend}

These methods mutate and return the receiver, they don't create
and return a new string.

Fixes [Bug #18241]
Revision 62a33dfa168504f8ee77d493979e66616ebe1da8 - 12/24/2021 05:36 AM - nagachika (Tomoyuki Chikanaga)
merge revision(s) c6706f15af123bdbb3b39a21903d85¢78462d047: [Backport #18241]

Fix documentation for String#{<<,concat,prepend}

These methods mutate and return the receiver, they don't create
and return a new string.
Fixes [Bug #18241]

string.c | 19 +++++++++t——-mmmm——
1 file changed, 10 insertions(+), 9 deletions(-)

Revision 62a33dfa16850418ee77d493979e66616ebe1da8 - 12/24/2021 05:36 AM - nagachika (Tomoyuki Chikanaga)
merge revision(s) c6706f15af123bdbb3b39a21903d85¢78462d047: [Backport #18241]

Fix documentation for String#{<<,concat,prepend}

These methods mutate and return the receiver, they don't create
and return a new string.

Fixes [Bug #18241]

string.c | 19 ++++++++tt——mmmmm—m
1 file changed, 10 insertions(+), 9 deletions(-)

Revision 62a33dfa - 12/24/2021 05:36 AM - nagachika (Tomoyuki Chikanaga)
merge revision(s) c6706f15af123bdbb3b39a21903d85¢78462d047: [Backport #18241]

Fix documentation for String#{<<,concat,prepend}

These methods mutate and return the receiver, they don't create
and return a new string.

Fixes [Bug #18241]

string.c | 19 +++++++++t——mmmmm——
1 file changed, 10 insertions(+), 9 deletions(-)

History

#1 - 10/05/2021 03:22 PM - hernanat (Anthony Hernandez)

edit: to be clear, I'm making a distinction between "new string" in the contents-sense, and "new string" in the memory location sense.

For example, the << operation on Array inserts an array entry and returns self, which is why | was initially confused when | saw that the result of
String#<< was a new string.

#2 - 10/05/2021 03:31 PM - jeremyevans0 (Jeremy Evans)
- Tracker changed from Misc to Bug
- Backport set to 2.6: UNKNOWN, 2.7: UNKNOWN, 3.0: UNKNOWN

This is a documentation bug. Both String#<< and String#concat mutate and return the receiver. I'll fix this shortly.

#3 - 10/05/2021 03:41 PM - jeremyevans (Jeremy Evans)
- Status changed from Open to Closed

Applied in changeset git|c6706f15af123bdbb3b39a21903d85¢78462d047.

Fix documentation for String#{<<,concat,prepend}

These methods mutate and return the receiver, they don't create
and return a new string.

Fixes [Bug #18241]

#4 - 10/22/2021 08:59 AM - mame (Yusuke Endoh)
- Has duplicate Bug #18261: String#prepend inconsistent documentation added

#5 - 10/22/2021 09:00 AM - mame (Yusuke Endoh)
- Backport changed from 2.6: UNKNOWN, 2.7: UNKNOWN, 3.0: UNKNOWN to 2.6: UNKNOWN, 2.7: UNKNOWN, 3.0: REQUIRED

#6 - 12/24/2021 06:05 AM - nagachika (Tomoyuki Chikanaga)
https://bugs.ruby-lang.org/projects/ruby-master/repository/git/revisions/c6706f15af123bdbb3b39a21903d85c78462d047
https://bugs.ruby-lang.org/issues/18241

- Backport changed from 2.6: UNKNOWN, 2.7: UNKNOWN, 3.0: REQUIRED to 2.6: UNKNOWN, 2.7: UNKNOWN, 3.0: DONE

ruby_3_0 62a33dfa168504f8ee77d493979e66616ebe1da8 merged revision(s) c6706f15af123bdbb3b39a21903d85¢78462d047.
